VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2250
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7920
   LinkTopic       =   "Form1"
   ScaleHeight     =   2250
   ScaleWidth      =   7920
   StartUpPosition =   3  'Windows Default
   Begin VB.Label lblCSDVersion 
      AutoSize        =   -1  'True
      Caption         =   "CSDVersion"
      Height          =   195
      Left            =   1800
      TabIndex        =   8
      Top             =   1800
      Width           =   855
   End
   Begin VB.Label lblCurrentVersion 
      AutoSize        =   -1  'True
      Caption         =   "CurrentVersion"
      Height          =   195
      Left            =   1800
      TabIndex        =   7
      Top             =   1080
      Width           =   1035
   End
   Begin VB.Label lblCurrentBuildNumber 
      AutoSize        =   -1  'True
      Caption         =   "CurrentBuildNumber"
      Height          =   195
      Left            =   1800
      TabIndex        =   6
      Top             =   1440
      Width           =   1410
   End
   Begin VB.Label lblProductName 
      AutoSize        =   -1  'True
      Caption         =   "ProductName"
      Height          =   195
      Left            =   1800
      TabIndex        =   5
      Top             =   720
      Width           =   975
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "CSDVersion"
      Height          =   195
      Index           =   3
      Left            =   120
      TabIndex        =   4
      Top             =   1800
      Width           =   855
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "CurrentVersion"
      Height          =   195
      Index           =   2
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   1035
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "CurrentBuildNumber"
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   1440
      Width           =   1410
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "ProductName"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   975
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   20.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Private Const ERROR_SUCCESS = 0&

Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_CURRENT_USER = &H80000001

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const SYNCHRONIZE = &H100000
Private Const KEY_ALL_ACCESS = _
    ((STANDARD_RIGHTS_ALL Or _
    KEY_QUERY_VALUE Or _
    KEY_SET_VALUE Or _
    KEY_CREATE_SUB_KEY Or _
    KEY_ENUMERATE_SUB_KEYS Or _
    KEY_NOTIFY Or KEY_CREATE_LINK) And _
    (Not SYNCHRONIZE))

Private Declare Function GetVersionExA Lib "kernel32" (lpVersionInformation As OSVERSIONINFO) As Integer
Private Type OSVERSIONINFO
   dwOSVersionInfoSize As Long
   dwMajorVersion As Long
   dwMinorVersion As Long
   dwBuildNumber As Long
   dwPlatformId As Long
   szCSDVersion As String * 128
End Type

Private Const REG_PRODUCT_KEY As String = "SOFTWARE\Microsoft\Windows NT\CurrentVersion"

' Return the registry value.
Private Function GetRegistryValue(ByVal hKey As Long, ByVal subkey_name As String) As String
Dim value As String
Dim length As Long
Dim value_type As Long

    length = 256
    value = Space$(length)
    If RegQueryValueEx(hKey, subkey_name, _
        0&, value_type, ByVal value, length) _
            <> ERROR_SUCCESS _
    Then
        value = "<Error>"
    Else
        ' Remove the trailing null character.
        value = Left$(value, length - 1)
    End If
    
    GetRegistryValue = value
End Function

' Return the OS version, build, and platform ID.
'            dwPlatformID  dwMajorVersion  dwMinorVersion
' Win3.1          0               ?               ?
' Win95           1               4               0
' Win98           1               4              10
' WinME           1               4              90
' NT 3.51         2               3              51
' NT 4.0          2               4               0
' Win2000         2               5               0
' WinXP           2               5               1
' Win2003         2               5               2
' Vista           2               6               0
' Win2008 Server  2               6               0
Public Function GetOSVersion() As String
Dim version_info As OSVERSIONINFO
Dim txt As String
Dim hKey As Long

    GetOSVersion = "Unknown"

    version_info.dwOSVersionInfoSize = 148
    version_info.szCSDVersion = Space$(128)
    GetVersionExA version_info

    Select Case version_info.dwPlatformId
        Case 0
            GetOSVersion = "Win 3.1"
        Case 1
            Select Case version_info.dwMinorVersion
                Case 0
                    GetOSVersion = "Win95"
                Case 10
                    GetOSVersion = "Win98"
                Case 90
                    GetOSVersion = "WinME"
                Case Else
                    GetOSVersion = "Unknown Win32"
            End Select
        Case 2
            Select Case version_info.dwMajorVersion
                Case 3
                    GetOSVersion = "NT 3.51"
                Case 4
                    GetOSVersion = "NT 4.0"
                Case 5
                    Select Case version_info.dwMinorVersion
                        Case 0
                            GetOSVersion = "Win2000"
                        Case 1
                            GetOSVersion = "WinXP"
                        Case 2
                            GetOSVersion = "Win2003"
                    End Select
                Case 6
                    If RegOpenKeyEx(HKEY_LOCAL_MACHINE, _
                        REG_PRODUCT_KEY, _
                        0&, KEY_QUERY_VALUE, hKey) <> ERROR_SUCCESS _
                    Then
                        txt = ""
                    Else
                        txt = GetRegistryValue(hKey, "ProductName")

                        ' Close the key.
                        If RegCloseKey(hKey) <> ERROR_SUCCESS Then
                            MsgBox "Error closing key."
                        End If
                    End If

                    txt = LCase$(txt)
                    If InStr(txt, "vista") > 0 Then
                        GetOSVersion = "Vista"
                    ElseIf InStr(txt, "server") > 0 Then
                        GetOSVersion = "Win2008"
                    Else
                        GetOSVersion = "Unknown Win32NT6"
                    End If
                Case Else
                    GetOSVersion = "Unknown Win32NT"
            End Select
        Case 3
            GetOSVersion = "Win CE"
        Case 4
            GetOSVersion = "Unix"
    End Select

    GetOSVersion = "Unknown"
End Function

Private Sub Form_Resize()
    Label1.Width = Me.ScaleWidth
End Sub

Private Sub Form_Load()
Dim hKey As Long

    Label1.Caption = Environ("OS")

    ' Get the interpreted version information.
    ' Open the key.
    If RegOpenKeyEx(HKEY_LOCAL_MACHINE, _
        REG_PRODUCT_KEY, _
        0&, KEY_QUERY_VALUE, hKey) <> ERROR_SUCCESS _
    Then
        MsgBox "Error opening key."
        Exit Sub
    End If

    ' Get the subkeys' values.
    lblProductName.Caption = GetRegistryValue(hKey, "ProductName")
    lblCurrentBuildNumber.Caption = GetRegistryValue(hKey, "CurrentBuildNumber")
    lblCurrentVersion.Caption = GetRegistryValue(hKey, "CurrentVersion")
    lblCSDVersion.Caption = GetRegistryValue(hKey, "CSDVersion")

    ' Close the key.
    If RegCloseKey(hKey) <> ERROR_SUCCESS Then
        MsgBox "Error closing key."
    End If
End Sub
